import moment from 'moment';
import jwt from 'jsonwebtoken';

export default class AccessToken {
  encodedToken: string;

  expiresAt: moment.Moment;

  groups: Array<string>;

  constructor(encodedToken: string) {
    this.encodedToken = encodedToken;
    const decodedToken = jwt.decode(encodedToken) as {[key: string]: any};
    // Time is in seconds, but we except milliseconds
    this.expiresAt = moment(decodedToken.exp * 1000);
    this.groups = decodedToken.groups;
  }
}
