export default class Issuer {
  clientId: string;

  tokenEndpoint: string;

  authEndpoint: string;

  redirectUri: string;

  constructor(parameter: any) {
    this.clientId = parameter.clientId;
    this.tokenEndpoint = parameter.tokenEndpoint;
    this.authEndpoint = parameter.authEndpoint;
    this.redirectUri = parameter.redirectUri;
  }

  generateAuthorizationUrl(state: string) {
    console.log(this.authEndpoint);
    const parameter = new URLSearchParams({
      // eslint-disable-next-line
      response_type: 'code',
      // eslint-disable-next-line
      client_id: this.clientId,
      // eslint-disable-next-line
      redirect_uri: this.redirectUri,
      state,
    });
    return `${this.authEndpoint}?${parameter}`;
  }

  async getToken(code: string) {
    return this.aquireToken({
      // eslint-disable-next-line
      grant_type: 'authorization_code',
      // eslint-disable-next-line
      redirect_uri: this.redirectUri,
      code,
    });
  }

  async refreshToken(refreshToken: string) {
    return this.aquireToken({
      // eslint-disable-next-line
      grant_type: 'refresh_token',
      // eslint-disable-next-line
      refresh_token: refreshToken,
    });
  }

  async aquireToken(parameter: any) {
    return fetch(
      this.tokenEndpoint,
      {
        method: 'POST',
        body: new URLSearchParams({
          // eslint-disable-next-line
          client_id: this.clientId,
          ...parameter,
        }),
      },
    ).then((response: Response) => response.json());
  }
}
